C I_Hp.f
C
C VIS-5D function to calculate PERTURBATION balanced geopotential height (I_Hp)

C ==============================================================================

      INTEGER FUNCTION USERFUNC( OUTGRID, OUTNL, OUTLOWLEV,
     *                           INGRID, NR, NC, NL, LOWLEV, MAXNL,
     *                           NVARS, NAMES,
     *                           DATE, TIME,
     *                           PROJECTION, PROJ_ARGS,
     *                           VERTICAL, VERT_ARGS )
C ARGUMENTS:
      implicit none
      INTEGER NVARS
      INTEGER NR, NC, NL(NVARS), LOWLEV(NVARS), MAXNL
      REAL OUTGRID(NR,NC,MAXNL)
      INTEGER OUTNL, OUTLOWLEV
      REAL INGRID(NR,NC,MAXNL,NVARS)
      CHARACTER*8 NAMES(NVARS)
      INTEGER DATE, TIME
      INTEGER PROJECTION
      REAL PROJ_ARGS(*)
      INTEGER VERTICAL
      REAL VERT_ARGS(*)

C LOCAL VARS:
      integer var, ir, ic, il
      integer ii_h, ii_hm  

C ==============================================================================
      
C Specify number of levels in OUTGRID
      OUTNL = MAXNL
      OUTLOWLEV = 0
      
C Find the I_H and I_Hm variables (TOTAL and MEAN fields)
      ii_h = -1
      ii_hm = -1
      do var=1,nvars
        if (names(var) .eq. 'I_H') ii_h = var
        if (names(var) .eq. 'I_Hm') ii_hm = var        
      end do

C If I_H or I_Hm not found, return error 1
      if ( ii_h.eq.-1 .or. ii_hm.eq.-1 ) then
        print *, 
     $  "Couldn't find I_H or I_Hm vars!"
        userfunc = 1
        return
      endif

C ==============================================================================

C OUTPUT OF PERTURBATION BALANCED GEOPOTENTIAL HEIGHT I_Hp (=I_H-I_Hm) 

      print*,
     $'Output of PERTURBATION balanced geopotential height I_Hp (m)'
      DO 9999 ir=1,nr
      DO 9999 ic=1,nc
      DO 9999 il=1,maxnl
        outgrid(ir,ic,il)=ingrid(ir,ic,il,ii_h)-
     $                    ingrid(ir,ic,il,ii_hm)
9999  CONTINUE     

C ==============================================================================
               
      USERFUNC = 0
      RETURN
      END

C ==============================================================================
